#pragma once
extern "C" {
	/**
	 * A small function, that always returns 0
	 */
	uint64_t _small(void);

	/**
	 * This function checks if the parameter is even or odd, and then
	 * always returns 0.
	 *
	 * The check is done with a branch, so the hooking engine has to take that
	 * into account.
	 *
	 * @param Number to be checked
	 */
	uint64_t  _branch(uint64_t);

	/**
	 * Replicates the MSVCRT rand().
	 *
	 * This function is used to check whether the hooking engine correctly fixes
	 * rip relative addressing.
	 *
	 * @internal: 
	 * static seed = 1;
	 * return( ((seed = seed * 214013L
     *       + 2531011L) >> 16) & 0x7fff );
	 */
	uint64_t  _rip_relative(void);
};
